/**
 * **************************************************
 * **************************************************
 *   _____ _____  ______   _
 *  / ____|  __ \|  ____| | |
 * | |    | |__) | |__    | |    _   _  ___  _ __
 * | |    |  ___/|  __|   | |   | | | |/ _ \| '_ \
 * | |____| |    | |____  | |___| |_| | (_) | | | |
 *  \_____|_|    |______| |______\__, |\___/|_| |_|
 *                                __/ |
 *                               |___/
 * **************************************************
 * **************************************************
 *
 *
 *
 * Fonctions d'aide permettant de construire directement une piece particuliere
 *  aux coordonnees souhaitees.
 * L'appel a ces fonctions ne devrait pas avoir a apparaitre sur le code de haut niveau
 *  qui doit pouvoir directement initialiser un echiquier. Aucun fichier de haut niveau
 *  ne doit donc avec directement acces aux fonctions de constructeur_piece.h.
 *
 */

//#Nom1: ZZZ
//#Prenom1: ZZZZ
//#Nom2: ZZZ
//#Prenom2: ZZZZ
//#Groupe: Z

#ifndef CONSTRUCTEUR_PIECE_H
#define CONSTRUCTEUR_PIECE_H

#include "piece.h"

/**
 * Fonction constructeur_piece_<TYPE>:
 * ********************************
 *   Construit une piece de type <TYPE> aux coordonnees indiquees
 *   TYPE pouvant valoir: tour, cavalier, fou, roi, reine, pion_blanc, pion_noir.
 *
 *   Necessite:
 *     - Un pointeur non constant vers une piece de jeu. Le pointeur doit etre non NULL.
 *     - Deux coordonnees valides.
 *   Garantie:
 *     - La piece de jeu est de type <TYPE> et possede les coordonnees indiquees en parametres.
 *     - La piece de jeu est valide.
 */
void constructeur_piece_tour      (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y);
void constructeur_piece_cavalier  (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y);
void constructeur_piece_fou       (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y);
void constructeur_piece_roi       (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y);
void constructeur_piece_dame      (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y);
void constructeur_piece_pion_blanc(piece *piece_de_jeu,int coordonnee_x,int coordonnee_y);
void constructeur_piece_pion_noir (piece *piece_de_jeu,int coordonnee_x,int coordonnee_y);




#endif
