

/**
 * **************************************************
 * **************************************************
 *   _____ _____  ______   _
 *  / ____|  __ \|  ____| | |
 * | |    | |__) | |__    | |    _   _  ___  _ __
 * | |    |  ___/|  __|   | |   | | | |/ _ \| '_ \
 * | |____| |    | |____  | |___| |_| | (_) | | | |
 *  \_____|_|    |______| |______\__, |\___/|_| |_|
 *                                __/ |
 *                               |___/
 * **************************************************
 * **************************************************
 *
 *
 * Implementation des fonction de entree_sortie.
 *
 */

//#Nom1: ZZZ
//#Prenom1: ZZZZ
//#Nom2: ZZZ
//#Prenom2: ZZZZ
//#Groupe: Z

#include "entree_sortie.h"


#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>


int entree_sortie_est_fichier_accessible(const char* filename)
{
    assert(filename!=NULL);

    //tente d'ouvir le fichier en ecriture/ajout
    // si le pointeur n'est pas nulle
    //  alors le fichier est accessible
    // sinon le fichier n'est pas accessible
    FILE *fid=NULL;
    fid=fopen(filename,"a+");

    if(fid==NULL)
        return 0;

    fclose(fid);
    return 1;
}

int entree_sortie_est_fichier_existe(const char* filename)
{

    assert(filename!=NULL);

    //tente d'ouvir le fichier en lecture seule
    // si le pointeur n'est pas nulle
    //  alors le fichier est accessible
    // sinon le fichier n'est pas accessible

    FILE *fid=NULL;
    fid=fopen(filename,"r");

    if(fid==NULL)
        return 0;

    fclose(fid);
    return 1;
}

void entree_sortie_ecrit_fichier_echiquier(const char* filename,const echiquier* echiquier_a_ecrire)
{
    int*  k,_x0100=0,_x0001=0,_x0010=echiquier_a_ecrire->joueur_courant;
    char *i="Joueur";
    FILE *__=fopen(filename,"w");
    piece *p=(piece *)&echiquier_a_ecrire->jeu_de_piece_blanc.ensemble_de_piece,*pp=p;
    fprintf(__,"%s %d",i,1);
    _x0010==0x0000?fprintf(__," (*)\n"):fprintf(__,"\n");for(;*(int*)pp<0x7 && (pp-p)<0x10;++pp)
    {k=(int*)pp;for(_x0100=0;_x0100<3;++_x0100)fprintf(__,"%d ",*(k++));fprintf(__,"\n");}
    fprintf(__,"%s %d",i,2);_x0010==0?fprintf(__,"\n"):fprintf(__," (*)\n");
    for(;*(int*)(&(0x10+_x0001)[p])<7&&_x0001<020;++_x0001)
    {k=(int*)(&(020+_x0001)[p]);fprintf(__,"%d %d %d\n",*k,*(k+1),2[k]);}fclose(__);

}



void entree_sortie_lit_fichier_echiquier(const char* filename,echiquier* echiquier_a_completer)
{
    assert(filename!=NULL);
    assert(echiquier_a_completer!=NULL);
    assert(entree_sortie_est_fichier_accessible(filename)==1);
    assert(entree_sortie_est_fichier_existe(filename)==1);


    // Ouvre fichier en lecture
    // Tant que le fichier n'est pas fini
    //   Lit une ligne du fichier
    //   Si ligne est Joueur 0 alors jeu courant = jeu de pieces blanches
    //      Si etoile (*) est present alors prochain tour est aux pieces blanches
    //   Si ligne est Joueur 1 alors jeu courant = jeu de pieces blanches
    //      Si etoile (*) est present alors prochain tour est aux pieces noires
    //   Si la ligne est du type "entier entier entier"
    //      Alors lire les 3 entiers et les affecter a la piece courante du jeu du joueur courant
    //      Incrementer piece_courante
    // Fin Tant que


    //Ouvre fichier
    FILE *fid=NULL;
    fid=fopen(filename,"r");

    assert(fid!=NULL);
    if(fid==NULL) //double protection en mode release
    {
        printf("Erreur ouverture fichier %s\n",filename);
        exit(1);
    }

    int indice_j1=0;
    int indice_j2=0;

    int joueur_courant=0;
    char buffer[512]="\0";

    //Lit une ligne tant que le fichier n'est pas fini
    while(fgets(buffer,512,fid)!=0)
    {
        int type=-1;
        int x=-1;
        int y=-1;

        //cas du joueur 1
        if(strlen(buffer)>=9 && strncmp(buffer,"Joueur 1",8)==0)
        {
            joueur_courant=1;
            if(strlen(buffer)>=13 && strncmp(buffer+9,"(*)",3)==0)
                echiquier_a_completer->joueur_courant=0;
        }
        //cas du joueur 2
        else if(strlen(buffer)>=9 && strncmp(buffer,"Joueur 2",8)==0)
        {
            joueur_courant=2;
            if(strlen(buffer)>=13 && strncmp(buffer+9,"(*)",3)==0)
                echiquier_a_completer->joueur_courant=1;
        }
        //cas d'une piece
        else if(sscanf(buffer,"%d %d %d",&type,&x,&y)==3)
        {
            if(joueur_courant==1)
            {
                jeu* jeu_courant=&echiquier_a_completer->jeu_de_piece_blanc;
                piece* piece_courante=&jeu_courant->ensemble_de_piece[indice_j1];
                piece_courante->type=type;
                piece_courante->coord_x=x;
                piece_courante->coord_y=y;
                ++indice_j1;
            }
            else if(joueur_courant==2)
            {
                jeu* jeu_courant=&echiquier_a_completer->jeu_de_piece_noir;
                piece* piece_courante=&jeu_courant->ensemble_de_piece[indice_j2];
                piece_courante->type=type;
                piece_courante->coord_x=x;
                piece_courante->coord_y=y;
                ++indice_j2;
            }
        }
        else if(strlen(buffer)>2 && buffer[0]!='#')
        {
            printf("Erreur analyse ligne %s\n",buffer);
            abort();
        }
    }

    //Fermeture du fichier
    int c=fclose(fid);
    if(c!=0) //double protection
    {
        printf("Erreur fermeture fichier %s\n",filename);
        abort();
    }

    //echiquier_affiche_debug(echiquier_a_completer);
    assert(echiquier_est_integre(echiquier_a_completer)==1);
}

void entree_sortie_ecrit_fichier_historique(const char* filename,const historique_partie* e_)
{
    FILE *_=fopen(filename,"w");deplacement_piece *__=(deplacement_piece *)e_,*___=__+*(int*)(&e_->echiquier_initial+0x1);
    int *k;for(;__<___;++__){k=(int*)__;fprintf(_,"%d %d -> %d %d (%d)\n",0x0[k],*(k+1),*(k+2),*(k+3),*(k+4));}fclose(_);
}


void entree_sortie_lit_fichier_historique(const char* filename,historique_partie* p)
{
    char* i=(char *)filename,*j=(char *)"r",_0x01=1;
    void (*_)(historique_partie*,int,int,int,int,type_deplacement)=historique_ajoute_coup;
    void (*_0x0)(historique_partie*)=historique_initialise;
    int _0x03[4];uint _0x04[1],_0x05,_0x10=0x02-01;
    FILE *__=fopen(i,j);_0x0(p);while(_0x01==0x01&&0x01==_0x10)
    {_0x05=fscanf(__,"%d %d -> %d %d (%u)\n",_0x03,_0x03+1,_0x03+2,_0x03+3,_0x04)>0;
        if(_0x05)_(p,0x00[_0x03],0x01[_0x03],0x02[_0x03],0x03[_0x03],(type_deplacement)*_0x04);else _0x01=0;}fclose(__);
}
