
#include "structures_echiquier.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int jeu_nombre_piece(const struct jeu *j)
{

  int counter=0;
  for(counter=0;counter<MAX_PIECE && piece_est_valide(&(j->donnee[counter]))==1;++counter);
  return counter;
}

int jeu_cherche_piece(const struct jeu* jeu_joueur,unsigned int x,unsigned int y)
{
  int N=jeu_nombre_piece(jeu_joueur);

  int k=0;
  for(k=0;k<N;++k)
    {
      const struct piece* p=&(jeu_joueur->donnee[k]);
      if(p->px==(int)x && p->py==(int)y)
	return p->type;
    }

  return -1;
    
}


int piece_est_valide(const struct piece *p)
{
  if(p->px>=0 && p->py>=0 && p->type>=0 && p->type<=7)
    return 1;
  
  return 0;
}

void echiquier_lit(struct jeu *j1,struct jeu *j2,const char *fichier,int *joueur_a_jouer)
{

  //init echiquier
  int k=0;
  for(k=0;k<16;++k)
    {
      j1->donnee[k].type=7;
      j1->donnee[k].px=-1;
      j1->donnee[k].py=-1;
      
      j2->donnee[k].type=7;
      j2->donnee[k].px=-1;
      j2->donnee[k].py=-1;
    }




    FILE *fid=NULL;
    fid=fopen(fichier,"r");

    if(fid==NULL)
    {
        printf("Erreur ouverture fichier %s\n",fichier);
        exit(1);
    }

    int indice_j1=0;
    int indice_j2=0;

    int joueur_courant=0;
    char buffer[512];
    while(fgets(buffer,512,fid)!=0)
    {
        if(strlen(buffer)>=9 && strncmp(buffer,"Joueur 1",8)==0)
        {
            joueur_courant=1;
            if(strlen(buffer)>=13 && strncmp(buffer+9,"(*)",3)==0)
                *joueur_a_jouer=1;
        }
        if(strlen(buffer)>=9 && strncmp(buffer,"Joueur 2",8)==0)
        {
            joueur_courant=2;
            if(strlen(buffer)>=13 && strncmp(buffer+9,"(*)",3)==0)
                *joueur_a_jouer=2;
        }


        int type=-1;
        int x=-1;
        int y=-1;
        if(sscanf(buffer,"%d %d %d",&type,&x,&y)==3)
        {
            if(joueur_courant==1)
            {
                j1->donnee[indice_j1].type=type;
                j1->donnee[indice_j1].px=x;
                j1->donnee[indice_j1].py=y;
                ++indice_j1;

            }
            else if(joueur_courant==2)
            {
                j2->donnee[indice_j2].type=type;
                j2->donnee[indice_j2].px=x;
                j2->donnee[indice_j2].py=y;
                ++indice_j2;
            }
        }

    }


    fclose(fid);
}
