 
/********************************************************/
/* Chargement fichier off                               */
/********************************************************/

/* inclusion des fichiers d'en-tete Glut */
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>

#include "structures_echiquier.h"

/**************************/
/** Variables globales */
/**************************/

//Chemin par defaut vers l'etat d'echiquier a lire.
const char *fichier_a_lire="../bin/echec_etat.txt";


//nombre de tours joues
int numero_de_tour=0;


/** L'affichage d'un jeu */
void affiche_echiquier(const struct jeu* jeu_joueur_1,const struct jeu* jeu_joueur_2,int joueur_courant);

void affiche_piece_blanche(int p);
void affiche_piece_noire(int p);


int main(int argc,char **argv)
{

  printf("Lance visualiseur (2D) avec %d arguments\n",argc);
  printf("Note: ./visualiseur <Chemin_fichier> permet de lire le fichier designe\n\n");
  
  //Le premier argument contient le chemin vers le fichier a lire.
  if(argc>=2)
    {
      fichier_a_lire=argv[1];
    }
  printf("Visualiseur lit fichier %s\n",fichier_a_lire);
  printf("\n\n");

  printf("terminologie:\n");
  printf("b/w=black/white\n");
  printf("R=Rook (tour)\n");
  printf("H=Horse/Knight (cavalier)\n");
  printf("B=Bishop (fou)\n");
  printf("Q=Queen (reine)\n");
  printf("K=King (roi)\n");
  printf("\n");


  //les jeux des deux joueurs
  struct jeu jeu_joueur_1;
  struct jeu jeu_joueur_2;

  //numero du joueur courant
  int joueur_a_jouer=1;


  //derniere modification du fichier stockant le jeu
  time_t derniere_modification_fichier=0;
  while(1)
    {

      struct stat stat_buffer;
      int stat_return;
      stat_return=stat(fichier_a_lire,&stat_buffer);
      if(stat_return!=0)
	printf("Erreur stat fichier\n");
      if(derniere_modification_fichier!=stat_buffer.st_mtime)
	{
	  
	  //lecture de l'echiquier
	  derniere_modification_fichier=stat_buffer.st_mtime;
	  echiquier_lit(&jeu_joueur_1,&jeu_joueur_2,fichier_a_lire,&joueur_a_jouer);
	  
	  affiche_echiquier(&jeu_joueur_1,&jeu_joueur_2,joueur_a_jouer);
	  printf("\n\n");
	}

      sleep(1);
    }
  
  return 0;
}


void affiche_echiquier(const struct jeu* jeu_joueur_1,const struct jeu* jeu_joueur_2,int joueur_courant)
{

  //affiche en-tete
  printf("Tour %d\n",numero_de_tour);
  printf("Joueur courant: ");
  if(joueur_courant==1)
    printf("blanc\n");
  else
    printf("noir\n");
  printf("\n\n");
  numero_de_tour++;
  

  //affiche echiquier
  int kx=0;
  int ky=0;
  for(ky=7;ky>=0;--ky)
    {
      //numero de colonne
      printf("%d ",ky);
      for(kx=0;kx<8;++kx)
	{
	  printf("|");
	  int p1=jeu_cherche_piece(jeu_joueur_1,kx,ky);
	  int p2=jeu_cherche_piece(jeu_joueur_2,kx,ky);

	  //2 pieces au meme endroit:
	  if(p1!=-1 && p2!=-1)
          {
             printf("??%d,%d",p1,p2);
          }

	  //pas de piece
	  if(p1==-1 && p2==-1)
	    printf("  ");

	  //une piece blanche
	  if(p1!=-1)
	    affiche_piece_blanche(p1);

	  //une piece noire
	  if(p2!=-1)
	    affiche_piece_noire(p2);

	}

      printf("|\n");

    }

  //affiche numero de lignes
  printf("\n  ");
  for(kx=0;kx<8;++kx)
    printf(" %d ",kx);
  printf("\n");
}

void affiche_piece_blanche(int p)
{
  switch(p)
    {
    case 0:
      printf("wR");
      break;
    case 1:
      printf("wH");
      break;
    case 2:
      printf("wB");
      break;
    case 3:
      printf("wQ");
      break;
    case 4:
      printf("wK");
      break;
    case 5:
      printf("wP");
      break;
    default:
      printf("??");
      break;
    };
}

void affiche_piece_noire(int p)
{
  switch(p)
    {
    case 0:
      printf("bR");
      break;
    case 1:
      printf("bH");
      break;
    case 2:
      printf("bB");
      break;
    case 3:
      printf("bQ");
      break;
    case 4:
      printf("bK");
      break;
    case 6:
      printf("bP");
      break;
    default:
      printf("??");
      break;
    };
}



